// endian.c
//
// test to show "endian-ness".
//

#include <stdio.h>

int main(int argc, char *argv[]) {
    int i;
    union {
        unsigned short int bin;
        unsigned char hex[2];
    } halfword;

    union	{ 
		unsigned int bin;
        unsigned char hex[4];
    } fullword;

    halfword.bin = 0x1234;
    fprintf(stderr,"halfword.bin = %04x,     ", halfword.bin);
    fprintf(stderr,"halfword.hex = %02x%02x\n", halfword.hex[0], halfword.hex[1]);

    fullword.bin = 0x12345678;
    fprintf(stderr,"fullword.bin = %08x, fullword.hex = ", fullword.bin);
    for (i = 0; i < 4; i++) {
        fprintf(stderr,"%02x", fullword.hex[i]);
    }
    fprintf(stderr,"\n");

    if ( (halfword.hex[0] == 0x34) && (fullword.hex[0] == 0x78) ) {
        fprintf(stderr,"Your machine is little endian. (e.g., x86...).\n");
    	return 0;
    }
    else 
    if ( (halfword.hex[0] == 0x12) && (fullword.hex[0] == 0x12) ) {
        fprintf(stderr,"Your machine is big    endian. (e.g., ppc...).\n");
    	return 1;
    }
	else  
    if ( (halfword.hex[0] == 0x12) && (fullword.hex[0] == 0x12) ) {
        fprintf(stderr,"Unable to determine endian' ness.\n");

    	fprintf(stderr,"halfword.bin = %04x,     ", halfword.bin);
    	fprintf(stderr,"halfword.hex = %02x%02x\n", halfword.hex[0], halfword.hex[1]);

    	fprintf(stderr,"fullword.bin = %08x, fullword.hex = ", fullword.bin);
    	for (i = 0; i < 4; i++) {
        	fprintf(stderr,"%02x", fullword.hex[i]);
    	}
    	fprintf(stderr,"\n");
    	return -1 ;
    }

}
